/***************************************************************/
/*   Author: Erwan Loisant (including code from Todd Rudick)   */
/*   Date: September 2003                                      */
/*   Licence: General Public Licence                           */
/***************************************************************/

const MOJI_PREF_TOPIC = "mojiPrefUpdate";
var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);

var dictds;
var rdfService;
var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
var mojiBranch = pref.getBranch("moji.");
var serverDicts = [];
var dictsets = [];
var uniconv = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
uniconv.charset = "UTF-8";

var strbundle;
var selectdict;

var installRequired = 0;

// for userdefined shortcuts.
var modifiers = Array("shift", "alt", "meta", "control", "accel", "access");
var keysets = Array("word", "kanji");
  
var observer = {
  onBeginLoad : function(sink){},
  onInterrupt : function(sink){},
  onResume : function(sink){},
  onError : function(sink,status,msg){ alert("rdf error: 0x" + status.toString(16) + " msg " + msg); },
 
  onEndLoad : function(sink){
    sink.removeXMLSinkObserver(this);
    mergeDS();    
  }
};

function listboxSelect(event)
{
  var dictbox;
  var dict /*, deactdict */;
  var up, down, left, right;
  var lbox = event.target;
    
  if ( lbox.id == "kanjidict" /* || lbox.id == "deactkanjidict" */ ) {
    dict = document.getElementById("kanjidict");
    // deactdict = document.getElementById("deactkanjidict");
    
    dictbox =  ( lbox.id == "kanjidict" );

	up = document.getElementById("kup");
	down = document.getElementById("kdown");
	left = document.getElementById("kleft");
	right = document.getElementById("kright");
  } else {
    dict = document.getElementById("dict");
    // deactdict = document.getElementById("deactdict");

	dictbox = ( lbox.id == "dict" );
	
	up = document.getElementById("up");
	down = document.getElementById("down");
	left = document.getElementById("left");
	right = document.getElementById("right");
  }
    
  var sel = lbox.selectedIndex;
  var count = lbox.childNodes.length;
  
  //if ( sel >= 0 ) {
  //  if ( dictbox ) {
  //    if ( deactdict.selectedIndex >= 0 )
  //      deactdict.selectedIndex = -1;
  //  } else {
  //    if ( dict.selectedIndex >= 0 )
  //      dict.selectedIndex = -1;
  //  }
  //}
  
  up.disabled = (sel == 0)
  down.disabled = (sel == count-1)
  left.disabled = dictbox;
  right.disabled = !dictbox;
}

function activateMenu(type)
{
  var left;

  if ( type == 1 ) {
	left = document.getElementById("kleft");
  } else {
	left = document.getElementById("left");
  }

  left.disabled = false;
}

function listboxDblClick(event)
{
  var dict, deactdict;
  var lbox = event.target;
   
  // if the user double click in the empty part of the listbox, ignore the event.
  if ( lbox.tagName == "listbox" ) 
    return;
    
  if ( lbox.parentNode.id == "kanjidict" /* || lbox.parentNode.id == "deactkanjidict" */ ) {
    dict = document.getElementById("kanjidict");
    deactdict = document.getElementById("deactkanjidict");
  } else {
    dict = document.getElementById("dict");
    deactdict = document.getElementById("deactdict");
  }
    
  var lb1, lb2;
  
  //if ( lbox.parentNode == dict ) {
	lb1 = dict;
	lb2 = deactdict;
  // } else {
    // lb1 = deactdict;
    // lb2 = dict;
  // }
    
  var item = lb1.removeItemAt(lb1.getIndexOfItem(lbox));
  var newItem = lb2.appendItem(item.label, item.value);
  if ( item.getAttribute("class") == "notinstalled" ) {
    newItem.setAttribute("class", "notinstalled");
  }
  //lb2.appendChild(item);
  //lb2.selectItem(item);
}

function buttonUp(type) {
  var dict, deactdict;
    
  if ( type == 1 ) {
    dict = document.getElementById("kanjidict");
    // deactdict = document.getElementById("deactkanjidict");
  } else {
    dict = document.getElementById("dict");
    // deactdict = document.getElementById("deactdict");
  }
    
  // var lb;
  
  //if ( dict.selectedIndex >= 0 )
  // lb = dict;
  //else
  // lb = deactdict;
  var lb = dict;
   
  var selIndex = lb.selectedIndex;
  var item = lb.removeItemAt(selIndex);
  var previtem = lb.getItemAtIndex(selIndex-1);
  lb.insertBefore(item, previtem);
  lb.selectItem(item);
}

function buttonDown(type) {
  var dict, deactdict;
    
  if ( type == 1 ) {
    dict = document.getElementById("kanjidict");
    // deactdict = document.getElementById("deactkanjidict");
  } else {
    dict = document.getElementById("dict");
    //deactdict = document.getElementById("deactdict");
  }
    
  //var lb;
  
  //if ( dict.selectedIndex >= 0 )
  // lb = dict;
  //else
  // lb = deactdict;
  var lb = dict;
   
  var selIndex = lb.selectedIndex;
  var item = lb.removeItemAt(selIndex);
  
  if ( selIndex+1 >= lb.getRowCount() )
  {
    lb.appendChild(item);
  } else {
    var previtem = lb.getItemAtIndex(selIndex+1);
    lb.insertBefore(item, previtem);
  }
  
  lb.selectItem(item);
}

function buttonLeft(type) {
  var dict, deactdict;
    
  if ( type == 1 ) {
    lb2 = document.getElementById("kanjidict");
    lb1 = document.getElementById("deactkanjidict");
    left = document.getElementById("kleft");
  } else {
    lb2 = document.getElementById("dict");
    lb1 = document.getElementById("deactdict");
    left = document.getElementById("left");
  }

  var item = lb1.removeItemAt(lb1.selectedIndex);
  var newItem = lb2.appendItem(item.label, item.value);
  lb2.selectItem(newItem);
  if ( item.getAttribute("class") == "notinstalled" ) {
    newItem.setAttribute("class", "notinstalled");
  }
  lb1.setAttribute("label", selectdict);
}

function buttonRight(type) {
  var dict, deactdict;
    
  if ( type == 1 ) {
    lb1 = document.getElementById("kanjidict");
    lb2 = document.getElementById("deactkanjidict");
  } else {
    lb1 = document.getElementById("dict");
    lb2 = document.getElementById("deactdict");
  }
    
  var item = lb1.removeItemAt(lb1.selectedIndex);
  var newItem = lb2.appendItem(item.label, item.value);
  if ( item.getAttribute("class") == "notinstalled" ) {
    newItem.setAttribute("class", "notinstalled");
  }
}

function initSelector(actlb, deactlb, branchname, order)
{
  var dict = document.getElementById(actlb);
  var deactdict = document.getElementById(deactlb);
  
  dict.addEventListener("select", listboxSelect, true);
  // deactdict.addEventListener("select", listboxSelect, true);

  dict.addEventListener("dblclick", listboxDblClick, true);
  // deactdict.addEventListener("dblclick", listboxDblClick, true);
  
  var dictPrefBranch = pref.getBranch("moji." + branchname + ".");
  var children = dictPrefBranch.getChildList("", {});
  
  var installedDicts = [];
  var dictNames = {}
  
  var i = 0;
  
  for (i = 0; i < children.length; i++ ) {
    if ( children[i].indexOf('.') == -1 ) {
      if ( dictPrefBranch.getBoolPref(children[i]) ) {
		installedDicts.push(children[i]);
		dictNames[children[i]] = uniconv.ConvertToUnicode(dictPrefBranch.getCharPref(children[i] + ".name"));
      }
    }
  }

  var dictorder = mojiBranch.getCharPref(order).split(',');

  for ( i = 0; i < dictorder.length; i++) {
    if ( dictorder[i].length > 0 ) {
		if ( dictNames[dictorder[i]] != null ) {
		  dict.appendItem(dictNames[dictorder[i]], dictorder[i]);
		} else {
		  alert(order + " " + strbundle.getString("unknowndict") + ": " + dictorder[i]);
		}
	}
  }
  
  for ( i = 0; i < installedDicts.length; i++ ) {
    var isactive = false;
    
    for ( var j = 0; j < dict.getRowCount(); j++ ) {
      if ( dict.getItemAtIndex(j).value == installedDicts[i] ) {
        isactive = true;
        break;
      }
    }
    
    if ( ! isactive ) {
      deactdict.appendItem(dictNames[installedDicts[i]], installedDicts[i]);
    }
  }
}

function mergeDS()
{
  var name = rdfService.GetResource("http://moji.mozdev.org/rdf#name");
  var id = rdfService.GetResource("http://moji.mozdev.org/rdf#id");
  var url = rdfService.GetResource("http://moji.mozdev.org/rdf#url");

  for ( i = 0; i < dictsets.length; i++ ) {  
    var dictset = dictsets[i];
    
    var container = Components.classes["@mozilla.org/rdf/container;1"].createInstance(Components.interfaces.nsIRDFContainer);
    var dicts = rdfService.GetResource("http://moji.mozdev.org/" + dictset.branch);
    container.Init(dictds, dicts);
    var children = container.GetElements();
  
    var dictPrefBranch = pref.getBranch("moji." + dictset.branch + ".");
    var deactdict = document.getElementById(dictset.deactlb);

    while (children.hasMoreElements()) {
      var child = children.getNext();
    
      if ( child instanceof Components.interfaces.nsIRDFResource ) {
        // var s = "";
        var pack = {};
      
        var target = dictds.GetTarget(child, name, true);
        if ( target instanceof Components.interfaces.nsIRDFLiteral ) {
          // s = s + "Name: " + target.Value;
          pack.name = target.Value;
        }
        target = dictds.GetTarget(child, id, true);
        if ( target instanceof Components.interfaces.nsIRDFLiteral ) {
          // s = s + "\r\nID: " + target.Value;
          pack.id = target.Value;
        }
        target = dictds.GetTarget(child, url, true);
        if ( target instanceof Components.interfaces.nsIRDFLiteral ) {
          // s = s + "\r\nURL: " + target.Value;
          pack.url = target.Value;
        }
        
        // alert(s);
  
        var installed = false;
        
        try {      
          if ( dictPrefBranch.getBoolPref(pack.id) ) {
            installed = true;
          }
        } catch (e) {
        }
        
        if ( ! installed ) {
          serverDicts.push(pack);
          var item = deactdict.appendItem(pack.name, pack.id);
          item.setAttribute("class", "notinstalled");
        }
      }
    }
  }
}

function init() {
  var dictset = {};
  dictset.lb = "dict";
  dictset.deactlb = "deactdict";
  dictset.branch = "dicts";
  dictset.order = "dictorder";
  dictset.deact = "deactdicts";
  dictsets.push(dictset);
  
  dictset = {};
  dictset.lb = "kanjidict";
  dictset.deactlb = "deactkanjidict";
  dictset.branch = "kanjidicts";
  dictset.order = "kanjidictorder";
  dictset.deact = "deactkanjidicts";
  dictsets.push(dictset);
  
  strbundle = document.getElementById("strings");
  selectdict = document.getElementById("deactdict").label;

  for ( var i = 0; i < dictsets.length; i++ ) {
    dictset = dictsets[i];
    initSelector(dictset.lb, dictset.deactlb, dictset.branch, dictset.order);
  }
  
  document.getElementById("longestMatch").checked = mojiBranch.getBoolPref("longestMatch");
  
  // Kanji dictionary
  document.getElementById("halpernchk").checked = mojiBranch.getBoolPref("kanji.halpernchk");
  document.getElementById("classicalchk").checked = mojiBranch.getBoolPref("kanji.classicalchk");
  document.getElementById("nelsonchk").checked = mojiBranch.getBoolPref("kanji.nelsonchk");
  document.getElementById("newnelsonchk").checked = mojiBranch.getBoolPref("kanji.newnelsonchk");
  document.getElementById("fatherjdrchk").checked = mojiBranch.getBoolPref("kanji.fatherjdrchk");
  document.getElementById("kanjilearnerchk").checked = mojiBranch.getBoolPref("kanji.kanjilearnerchk");
  document.getElementById("pgochk").checked = mojiBranch.getBoolPref("kanji.pgochk");
  document.getElementById("skipchk").checked = mojiBranch.getBoolPref("kanji.skipchk");
  document.getElementById("unihexchk").checked = mojiBranch.getBoolPref("kanji.unihexchk");
  document.getElementById("tuttledicchk").checked = mojiBranch.getBoolPref("kanji.tuttledicchk");
  document.getElementById("tuttlekanjichk").checked = mojiBranch.getBoolPref("kanji.tuttlekanjichk");
  document.getElementById("fourchk").checked = mojiBranch.getBoolPref("kanji.fourchk");
  document.getElementById("moro1chk").checked = mojiBranch.getBoolPref("kanji.moro1chk");
  document.getElementById("moro2chk").checked = mojiBranch.getBoolPref("kanji.moro2chk");
  document.getElementById("henshallchk").checked = mojiBranch.getBoolPref("kanji.henshallchk");
  document.getElementById("gakkenchk").checked = mojiBranch.getBoolPref("kanji.gakkenchk");
  document.getElementById("heisigchk").checked = mojiBranch.getBoolPref("kanji.heisigchk");
  document.getElementById("pgo2chk").checked = mojiBranch.getBoolPref("kanji.pgo2chk");
  document.getElementById("koreanchk").checked = mojiBranch.getBoolPref("kanji.koreanchk");
  document.getElementById("pinyinchk").checked = mojiBranch.getBoolPref("kanji.pinyinchk");

  document.getElementById("defaultaction").selectedItem = document.getElementById("default" + mojiBranch.getCharPref("defaultaction"));
    
  for ( var i = 0; i < keysets.length; i++ ) {
    var keyset = keysets[i];
    var mods = mojiBranch.getCharPref(keyset + "ShortcutModifiers").split(",");
    
    for ( var j = 0; j < mods.length; j++ ) {
      var e = document.getElementById(keyset + mods[j]);
      
      if ( e ) {
        e.checked = true;
      }
    }
    
    var key = mojiBranch.getCharPref(keyset + "Shortcut");
    
    if ( key.length > 1 ) {
      document.getElementById(keyset + "keycode").value = key;
    } else {
      document.getElementById(keyset + "key").value = key;
    }
  }
  
  var serverdicts = mojiBranch.getCharPref("serverdicts");
  
  rdfService = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);
  
  var appName;
  var appVersion;
  
  if (typeof Components.interfaces.nsIXULAppInfo == "undefined") {
    // this is a 1.0.*
    var appId = null;
      
    try {
       appId = pref.getPref("app.id");
       appVersion = pref.getPref("app.version");
    }
    catch(ex) {}
      
    if (appId) {
       if (appId == "{ec8030f7-c20a-464f-9b0e-13a3a9e97384}")
          appName = "Firefox";
       else if (appId == "{3550f703-e582-4d05-9a08-453d09bdfdc6}")
          appName = "Thunderbird";
       else
          appName = "???";
    }
  } else {
    // this is a new 1.4+
    var appInfo = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULAppInfo);
      
    if (appInfo) {
       appName = appInfo.name;
       appVersion = appInfo.version;
    } 
  }
  
  // downloading dictionaries in the configuration window does not work for Thunderbird
  if ( appName == "Thunderbird" )
    return;
  
  // it does not work in FF 1.0.* either.
  var v = appVersion.split(".");
  
  if ( v[0] && v[0] >= 1 ) {
    if ( v[0] == 1 ) {
      if ( !v[1] || v[1] == 0 )
        return;
    }
  } else
    return;
  
  dictds = rdfService.GetDataSource(serverdicts);
  dictds.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
  
  if ( dictds.loaded ) {
    mergeDS();
  } else {
    dictds.QueryInterface(Components.interfaces.nsIRDFXMLSink);
    dictds.addXMLSinkObserver(observer);
  }
}

function getOrder(dict)
{
  var count = dict.getRowCount();
  var s = "";
  
  for ( var i = 0; i < count; i++ ) {
    var item = dict.getItemAtIndex(i);
    s = s + item.value + ",";
  }
  
  if ( s.length > 0 )
    s = s.substring(0, s.length-1);
    
  return s;
}

function getDeactOrder(dict)
{
  var count = dict.menupopup.childNodes.length;
  var s = "";
  
  for ( var i = 0; i < count; i++ ) {
    var item = dict.menupopup.childNodes.item(i);
    if ( item.getAttribute("class") != "notinstalled" )
      s = s + item.value + ",";
  }
  
  if ( s.length > 0 )
    s = s.substring(0, s.length-1);
    
  return s;
}

function installNotify(name, result) {
  alert("The package " + name + " was installed with a result of " + result); // LOCALE
  installRequired--;
}

function savePrefs() {
  // the dictionary selection.
  var xpi = new Object();
  installRequired = 0;
  
  for ( var i = 0; i < dictsets.length; i++) {
    var dict = document.getElementById(dictsets[i].lb);
    mojiBranch.setCharPref(dictsets[i].deact, getDeactOrder(document.getElementById(dictsets[i].deactlb)));
    mojiBranch.setCharPref(dictsets[i].order, getOrder(dict));
    
    for ( var j = 0; j < dict.getRowCount(); j++ ) {
      var item = dict.getItemAtIndex(j);
      
      if ( item.getAttribute("class") == "notinstalled" ) {
        for ( var k = 0; k < serverDicts.length; k++ ) {
          if ( serverDicts[k].id == item.value ) {
            installRequired++;
            xpi[serverDicts[k].name] = { URL: serverDicts[k].url,
                                        IconURL: "http://moji.mozdev.org/moji-icon3.png",
                                        toString: function () { return this.URL; }
                                      };
            break;
          }
        }
      }
    }
  }
  
  mojiBranch.setBoolPref("longestMatch", document.getElementById("longestMatch").checked);
  
  // Kanji dictionary
  mojiBranch.setBoolPref("kanji.classicalchk", document.getElementById("classicalchk").checked);
  mojiBranch.setBoolPref("kanji.halpernchk", document.getElementById("halpernchk").checked);
  mojiBranch.setBoolPref("kanji.nelsonchk", document.getElementById("nelsonchk").checked);
  mojiBranch.setBoolPref("kanji.newnelsonchk", document.getElementById("newnelsonchk").checked);
  mojiBranch.setBoolPref("kanji.fatherjdrchk", document.getElementById("fatherjdrchk").checked);
  mojiBranch.setBoolPref("kanji.kanjilearnerchk", document.getElementById("kanjilearnerchk").checked);
  mojiBranch.setBoolPref("kanji.pgochk", document.getElementById("pgochk").checked);
  mojiBranch.setBoolPref("kanji.skipchk", document.getElementById("skipchk").checked);
  mojiBranch.setBoolPref("kanji.unihexchk", document.getElementById("unihexchk").checked);
  mojiBranch.setBoolPref("kanji.tuttledicchk", document.getElementById("tuttledicchk").checked);
  mojiBranch.setBoolPref("kanji.tuttlekanjichk", document.getElementById("tuttlekanjichk").checked);
  mojiBranch.setBoolPref("kanji.fourchk", document.getElementById("fourchk").checked);
  mojiBranch.setBoolPref("kanji.moro1chk", document.getElementById("moro1chk").checked);
  mojiBranch.setBoolPref("kanji.moro2chk", document.getElementById("moro2chk").checked);
  mojiBranch.setBoolPref("kanji.henshallchk", document.getElementById("henshallchk").checked);
  mojiBranch.setBoolPref("kanji.gakkenchk", document.getElementById("gakkenchk").checked);
  mojiBranch.setBoolPref("kanji.heisigchk", document.getElementById("heisigchk").checked);
  mojiBranch.setBoolPref("kanji.pgo2chk", document.getElementById("pgo2chk").checked);
  mojiBranch.setBoolPref("kanji.koreanchk", document.getElementById("koreanchk").checked);
  mojiBranch.setBoolPref("kanji.pinyinchk", document.getElementById("pinyinchk").checked);

  var defaultaction = document.getElementById("defaultaction").selectedItem;
  
  if ( defaultaction ) {
    if ( defaultaction.id == "defaultword" )
      mojiBranch.setCharPref("defaultaction", "word");
    else if ( defaultaction.id == "defaultkanji" )
      mojiBranch.setCharPref("defaultaction", "kanji");
  }      

  for ( var i = 0; i < keysets.length; i++ ) {
    var keyset = keysets[i];
    var mods = "";
    
    for ( var j = 0; j < modifiers.length; j++ ) {
      if ( document.getElementById(keyset + modifiers[j]).checked ) {
        if ( mods )
          mods = mods + ",";
          
        mods = mods + modifiers[j];
      }
    }
    
    var key = document.getElementById(keyset + "key").value;
    var keycode = document.getElementById(keyset + "keycode").value;
    
    mojiBranch.setCharPref(keyset + "ShortcutModifiers", mods);
    
    if ( key ) {
      mojiBranch.setCharPref(keyset + "Shortcut", key);  
    } else {
      if ( keycode == "undefined" ) 
        mojiBranch.clearUserPref(keyset + "Shortcut");
      else
        mojiBranch.setCharPref(keyset + "Shortcut", keycode);
    }
  }
  
  if ( installRequired > 0 ) 
    InstallTrigger.install(xpi, installNotify);
  
  while ( installRequired > 0 ) {
    alert(strbundle.getString("waitinstall"));
  }
  
  alert(strbundle.getString("configeffectwarning"));
  
  observerService.notifyObservers(mojiBranch, MOJI_PREF_TOPIC, "update");

  return true;
}
